diff --git a/src/main/java/net/minecraft/core/item/ItemPebble.java b/src/main/java/net/minecraft/core/item/PebbleItem.java
similarity index 58%
rename from src/main/java/net/minecraft/core/item/ItemPebble.java
rename to src/main/java/net/minecraft/core/item/PebbleItem.java
index abe1f861e..69ded824f 100644
--- a/src/main/java/net/minecraft/core/item/ItemPebble.java
+++ b/src/main/java/net/minecraft/core/item/PebbleItem.java
@@ -1,14 +1,14 @@
 package net.minecraft.core.item;
 
 // Referenced classes of package net.minecraft.src:
-//            Item, ItemStack, World, EntitySnowball, 
-//            EntityPlayer
+//            Item, ItemStack, World, SnowballProjectile,
+//            Player
 
-import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.entity.projectile.EntityPebble;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.entity.projectile.PebbleProjectile;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
@@ -16,37 +16,37 @@ import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class ItemPebble
+public class PebbleItem
     extends Item
     implements IDispensable
 {
 
-    public ItemPebble(String name, int id)
+    public PebbleItem(String name, String namespaceId, int id)
     {
-        super(name, id);
+        super(name, namespaceId, id);
         maxStackSize = 64;
     }
 
 
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
     {
         itemstack.consumeItem(entityplayer);
         world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.5F, 0.4F / (itemRand.nextFloat() * 0.4F + 0.8F));
         if(!world.isClientSide)
         {
-            world.entityJoinedWorld(new EntityPebble(world, entityplayer));
+            world.entityJoinedWorld(new PebbleProjectile(world, entityplayer));
         }
         return itemstack;
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         int id = world.getBlockId(blockX, blockY, blockZ);
         int meta = world.getBlockMetadata(blockX, blockY, blockZ);
-        if (id != Block.overlayPebbles.id && Block.blocksList[id] != null && Block.blocksList[id].hasTag(BlockTags.PLACE_OVERWRITES))
+        if (id != Blocks.OVERLAY_PEBBLES.id && Block.blocksList[id] != null && Block.blocksList[id].hasTag(BlockTags.PLACE_OVERWRITES))
         {
             id = 0;
             meta = 0;
@@ -55,13 +55,13 @@ public class ItemPebble
         {
             return false;
         }
-        if (blockY == world.getHeightBlocks() - 1 && Block.overlayPebbles.blockMaterial.isSolid())
+        if (blockY == world.getHeightBlocks() - 1 && Blocks.OVERLAY_PEBBLES.blockMaterial.isSolid())
         {
             return false;
         }
 
         // Check if we're placing "inside" a layer
-        if (id == Block.overlayPebbles.id && side == Side.TOP)
+        if (id == Blocks.OVERLAY_PEBBLES.id && side == Side.TOP)
         {
 
             final int newMeta = meta + 1;
@@ -72,8 +72,8 @@ public class ItemPebble
 
             if (newMeta < 3)
             {
-                world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Block.overlayPebbles.id, newMeta);
-                world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Block.overlayPebbles, EnumBlockSoundEffectType.PLACE);
+                world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.OVERLAY_PEBBLES.id, newMeta);
+                world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
                 itemstack.consumeItem(entityplayer);
                 return true;
             }
@@ -92,11 +92,11 @@ public class ItemPebble
         }
 
         // Check if the block we're placing into is a layer
-        if (id == Block.overlayPebbles.id)
+        if (id == Blocks.OVERLAY_PEBBLES.id)
         {
             final int newMeta = meta + 1;
 
-            final AABB bbBox = AABB.getBoundingBoxFromPool(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
+            final AABB bbBox = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
             if (!world.checkIfAABBIsClear(bbBox) || !world.isBlockOpaqueCube(blockX, blockY - 1, blockZ))
             {
                 return false;
@@ -104,8 +104,8 @@ public class ItemPebble
 
             if (newMeta < 3)
             {
-                world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Block.overlayPebbles.id, newMeta);
-                world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Block.overlayPebbles, EnumBlockSoundEffectType.PLACE);
+                world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.OVERLAY_PEBBLES.id, newMeta);
+                world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
                 itemstack.consumeItem(entityplayer);
                 return true;
             }
@@ -113,13 +113,13 @@ public class ItemPebble
         }
 
         // Regular placement, as all else fails
-        if (world.canBlockBePlacedAt(Block.overlayPebbles.id, blockX, blockY, blockZ, false, side) && world.isBlockOpaqueCube(blockX, blockY - 1, blockZ))
+        if (world.canBlockBePlacedAt(Blocks.OVERLAY_PEBBLES.id, blockX, blockY, blockZ, false, side) && world.isBlockOpaqueCube(blockX, blockY - 1, blockZ))
         {
-            final Block block = Block.overlayPebbles;
-            if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Block.overlayPebbles.id, getPlacedBlockMetadata(itemstack.getMetadata())))
+            final Block block = Blocks.OVERLAY_PEBBLES;
+            if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.OVERLAY_PEBBLES.id, getPlacedBlockMetadata(itemstack.getMetadata())))
             {
-                Block.overlayPebbles.onBlockPlaced(world, blockX, blockY, blockZ, side, entityplayer, yPlaced);
-                world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Block.overlayPebbles, EnumBlockSoundEffectType.PLACE);
+                Blocks.OVERLAY_PEBBLES.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, entityplayer, yPlaced);
+                world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
                 itemstack.consumeItem(entityplayer);
             }
             return true;
@@ -130,8 +130,8 @@ public class ItemPebble
 
     @Override
     public void onDispensed(ItemStack itemStack, World world, double x, double y, double z, int xOffset, int zOffset, Random random) {
-        EntityPebble pebble = new EntityPebble(world, x, y, z);
-        pebble.setHeading(xOffset, 0.1D, zOffset, 1.1F, 6F);
-        world.entityJoinedWorld(pebble);
+        PebbleProjectile pebbleProjectile = new PebbleProjectile(world, x, y, z);
+        pebbleProjectile.setHeading(xOffset, 0.1D, zOffset, 1.1F, 6F);
+        world.entityJoinedWorld(pebbleProjectile);
     }
 }
diff --git a/src/main/java/net/minecraft/core/item/ItemPlaceable.java b/src/main/java/net/minecraft/core/item/PlaceableItem.java
similarity index 71%
rename from src/main/java/net/minecraft/core/item/ItemPlaceable.java
rename to src/main/java/net/minecraft/core/item/PlaceableItem.java
index 02ce828c2..994e9ebc0 100644
--- a/src/main/java/net/minecraft/core/item/ItemPlaceable.java
+++ b/src/main/java/net/minecraft/core/item/PlaceableItem.java
@@ -1,26 +1,26 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFluid;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.block.FluidBlock;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
 
-public class ItemPlaceable extends Item {
+public class PlaceableItem extends Item {
 	
 	public Block blockToPlace;
 	
-	public ItemPlaceable(String name, int id, Block blockToPlace) {
-		super(name, id);
+	public PlaceableItem(String name, String namespaceId, int id, Block blockToPlace) {
+		super(name, namespaceId, id);
 		
 		this.blockToPlace = blockToPlace;
 	}
 
 	@Override
-	public boolean onUseItemOnBlock(ItemStack stack, EntityPlayer player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	public boolean onUseItemOnBlock(ItemStack stack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		if(stack.stackSize <= 0) {
 			return false;
 		}
@@ -31,7 +31,7 @@ public class ItemPlaceable extends Item {
 			blockZ += side.getOffsetZ();
 		}
 		Block currentBlock = world.getBlock(blockX, blockY, blockZ);
-		boolean placedInside = currentBlock != null && !(currentBlock instanceof BlockFluid);
+		boolean placedInside = currentBlock != null && !(currentBlock instanceof FluidBlock);
 
 		if(blockY < 0 || blockY >= world.getHeightBlocks()) {
 			return false;
@@ -41,7 +41,7 @@ public class ItemPlaceable extends Item {
 				world.playSoundEffect(EVENT_BLOCK_BREAK, blockX, blockY, blockZ, world.getBlockId(blockX, blockY, blockZ));
 			}
 			if(world.setBlockWithNotify(blockX, blockY, blockZ, blockToPlace.id)) {
-				blockToPlace.onBlockPlaced(world, blockX, blockY, blockZ, side, player, yPlaced);
+				blockToPlace.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, yPlaced);
 				world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockToPlace, EnumBlockSoundEffectType.PLACE);
 			}
 			return true;
diff --git a/src/main/java/net/minecraft/core/item/ItemQuiver.java b/src/main/java/net/minecraft/core/item/QuiverItem.java
similarity index 74%
rename from src/main/java/net/minecraft/core/item/ItemQuiver.java
rename to src/main/java/net/minecraft/core/item/QuiverItem.java
index 9ca2a1c34..202b81b0c 100644
--- a/src/main/java/net/minecraft/core/item/ItemQuiver.java
+++ b/src/main/java/net/minecraft/core/item/QuiverItem.java
@@ -1,18 +1,20 @@
 package net.minecraft.core.item;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.player.inventory.slot.Slot;
+import org.jetbrains.annotations.Nullable;
 
 // Referenced classes of package net.minecraft.src:
 //            Item, Block, BlockLeaves, ItemStack,
-//            EntityLiving
+//            Mob
 
-public class ItemQuiver extends Item
+public class QuiverItem extends Item implements IArmorItem
 {
 
-    public ItemQuiver(String name, int id)
+    public QuiverItem(String name, String namespaceId, int id)
     {
-        super(name, id);
+        super(name, namespaceId, id);
         setMaxStackSize(1);
         setMaxDamage(192);
 
@@ -24,7 +26,7 @@ public class ItemQuiver extends Item
     }
     
     @Override
-    public ItemStack onInventoryInteract(EntityPlayer player, Slot slot, ItemStack stackInSlot, boolean isItemGrabbed) {
+    public ItemStack onInventoryInteract(Player player, Slot slot, ItemStack stackInSlot, boolean isItemGrabbed) {
     	ItemStack quiverItem;
     	if(isItemGrabbed) {
     		quiverItem = player.inventory.getHeldItemStack();
@@ -41,14 +43,14 @@ public class ItemQuiver extends Item
     			// Put arrows from quiver in slot
     			int amount = Math.min(64, arrowCount);
     			if(amount > 0) {
-    				ItemStack arrowStack = new ItemStack(Item.ammoArrow, amount, 0);
+    				ItemStack arrowStack = new ItemStack(Items.AMMO_ARROW, amount, 0);
     				
-    				if(slot.canPutStackInSlot(arrowStack)) {
+    				if(slot.mayPlace(arrowStack)) {
     					setArrowCount(quiverItem, arrowCount - amount);
     					stackInSlot = arrowStack;
     				}
     			}
-    		}else if(stackInSlot != null && stackInSlot.itemID == Item.ammoArrow.id) {
+    		}else if(stackInSlot != null && stackInSlot.itemID == Items.AMMO_ARROW.id) {
     			// Put arrows from slot in quiver
     			int amount = Math.min(freeSpace, stackInSlot.stackSize);
     			if(amount > 0) {
@@ -59,7 +61,7 @@ public class ItemQuiver extends Item
     	}else {
         	ItemStack grabbedItem = player.inventory.getHeldItemStack();
         	
-        	if(grabbedItem != null && grabbedItem.itemID == Item.ammoArrow.id) {
+        	if(grabbedItem != null && grabbedItem.itemID == Items.AMMO_ARROW.id) {
         		// Put grabbed arrows into quiver
         		int amount = Math.min(grabbedItem.stackSize, freeSpace);
         		if(amount > 0) {
@@ -75,7 +77,7 @@ public class ItemQuiver extends Item
         		int amount = Math.min(64, arrowCount);
         		if(amount > 0) {
             		setArrowCount(quiverItem, arrowCount - amount);
-            		player.inventory.setHeldItemStack(new ItemStack(Item.ammoArrow, amount, 0));
+            		player.inventory.setHeldItemStack(new ItemStack(Items.AMMO_ARROW, amount, 0));
         		}
         	}
     	}
@@ -96,4 +98,13 @@ public class ItemQuiver extends Item
     	return true;
     }
 
+	@Override
+	public @Nullable ArmorMaterial getArmorMaterial() {
+		return null;
+	}
+
+	@Override
+	public int getArmorPiece() {
+		return PIECE_CHEST;
+	}
 }
diff --git a/src/main/java/net/minecraft/core/item/ItemRope.java b/src/main/java/net/minecraft/core/item/RopeItem.java
similarity index 78%
rename from src/main/java/net/minecraft/core/item/ItemRope.java
rename to src/main/java/net/minecraft/core/item/RopeItem.java
index 1dc653271..f3dd0d599 100644
--- a/src/main/java/net/minecraft/core/item/ItemRope.java
+++ b/src/main/java/net/minecraft/core/item/RopeItem.java
@@ -1,20 +1,20 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFluid;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.block.FluidBlock;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
 
-public class ItemRope extends ItemPlaceable{
-    public ItemRope(String name, int id, Block blockToPlace) {
-        super(name, id, blockToPlace);
+public class RopeItem extends PlaceableItem {
+    public RopeItem(String name, String namespaceId, int id, Block blockToPlace) {
+        super(name, namespaceId, id, blockToPlace);
     }
     @Override
-    public boolean onUseItemOnBlock(ItemStack stack, EntityPlayer player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onUseItemOnBlock(ItemStack stack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if(stack.stackSize <= 0) {
             return false;
         }
@@ -39,7 +39,7 @@ public class ItemRope extends ItemPlaceable{
             blockZ += side.getOffsetZ();
         }
         Block currentBlock = world.getBlock(blockX, blockY, blockZ);
-        boolean placedInside = currentBlock != null && !(currentBlock instanceof BlockFluid);
+        boolean placedInside = currentBlock != null && !(currentBlock instanceof FluidBlock);
 
         if(blockY < 0 || blockY >= world.getHeightBlocks()) {
             return false;
@@ -49,7 +49,7 @@ public class ItemRope extends ItemPlaceable{
                 world.playSoundEffect(EVENT_BLOCK_BREAK, blockX, blockY, blockZ, world.getBlockId(blockX, blockY, blockZ));
             }
             if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockToPlace.id, placeOnSide ? 0b1000_0000 : 0)) {
-                blockToPlace.onBlockPlaced(world, blockX, blockY, blockZ, side, player, yPlaced);
+                blockToPlace.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, yPlaced);
                 world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockToPlace, EnumBlockSoundEffectType.PLACE);
             }
             return true;
diff --git a/src/main/java/net/minecraft/core/item/SaddleItem.java b/src/main/java/net/minecraft/core/item/SaddleItem.java
new file mode 100644
index 000000000..b7642c4b1
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/SaddleItem.java
@@ -0,0 +1,35 @@
+package net.minecraft.core.item;
+
+
+// Referenced classes of package net.minecraft.src:
+//            Item, PigMob, ItemStack, Mob
+
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.PigMob;
+import net.minecraft.core.entity.player.Player;
+
+public class SaddleItem extends Item
+{
+
+    public SaddleItem(String name, String namespaceId, int id)
+    {
+        super(name, namespaceId, id);
+        maxStackSize = 1;
+    }
+
+    @Override
+    public boolean useItemOnEntity(ItemStack itemstack, Mob entityliving, Player entityPlayer)
+    {
+        if(entityliving instanceof PigMob && itemstack.consumeItem(entityPlayer))
+        {
+            PigMob entitypig = (PigMob)entityliving;
+            if(!entitypig.getSaddled())
+            {
+                entitypig.setSaddled(true);
+                return true;
+            }
+        }
+
+        return false;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/item/ItemSeeds.java b/src/main/java/net/minecraft/core/item/SeedsItem.java
similarity index 58%
rename from src/main/java/net/minecraft/core/item/ItemSeeds.java
rename to src/main/java/net/minecraft/core/item/SeedsItem.java
index 3c55af613..a81fc1920 100644
--- a/src/main/java/net/minecraft/core/item/ItemSeeds.java
+++ b/src/main/java/net/minecraft/core/item/SeedsItem.java
@@ -1,28 +1,29 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class ItemSeeds extends Item {
+public class SeedsItem extends Item {
 	private int cropsId;
 
-	public ItemSeeds(String name, int id, Block cropsBlock) {
-		super(name, id);
+	public SeedsItem(String name, String namespaceId, int id, Block cropsBlock) {
+		super(name, namespaceId, id);
 		cropsId = cropsBlock.id;
 	}
 
 	@Override
-	public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
 			blockX += side.getOffsetX();
 			blockY += side.getOffsetY();
 			blockZ += side.getOffsetZ();
 		}
-		if(world.getBlockId(blockX, blockY - 1, blockZ) == Block.farmlandDirt.id && world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
+		if(world.getBlockId(blockX, blockY - 1, blockZ) == Blocks.FARMLAND_DIRT.id && world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
 			world.setBlockWithNotify(blockX, blockY, blockZ, cropsId);
 			world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Block.blocksList[cropsId], EnumBlockSoundEffectType.PLACE);
 			itemstack.consumeItem(entityplayer);
diff --git a/src/main/java/net/minecraft/core/item/ItemSign.java b/src/main/java/net/minecraft/core/item/SignItem.java
similarity index 58%
rename from src/main/java/net/minecraft/core/item/ItemSign.java
rename to src/main/java/net/minecraft/core/item/SignItem.java
index a8914be56..7d80dd70c 100644
--- a/src/main/java/net/minecraft/core/item/ItemSign.java
+++ b/src/main/java/net/minecraft/core/item/SignItem.java
@@ -1,29 +1,29 @@
 package net.minecraft.core.item;
 
 
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.TileEntitySign;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.SignBlockEntity;
 
 // Referenced classes of package net.minecraft.src:
 //            Item, World, Material, Block, 
-//            EntityPlayer, MathHelper, ItemStack, TileEntitySign
+//            Player, MathHelper, ItemStack, SignBlockEntity
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class ItemSign extends Item
+public class SignItem extends Item
 {
 
-    public ItemSign(String name, int id)
+    public SignItem(String name, String namespaceId, int id)
     {
-        super(name, id);
+        super(name, namespaceId, id);
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
     	int sideHit = side.getId();
         if(side == Side.BOTTOM)
@@ -43,21 +43,21 @@ public class ItemSign extends Item
         if(blockY < 0 || blockY >= world.getHeightBlocks()) {
         	return false;
         }
-        if(!Block.signPostPlanksOak.canPlaceBlockAt(world, blockX, blockY, blockZ))
+        if(!Blocks.SIGN_POST_PLANKS_OAK.canPlaceBlockAt(world, blockX, blockY, blockZ))
         {
             return false;
         }
         if(sideHit == 1)
         {
-            world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Block.signPostPlanksOak, EnumBlockSoundEffectType.PLACE);
-            world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Block.signPostPlanksOak.id, MathHelper.floor_double((double)(((entityplayer.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
+            world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.SIGN_POST_PLANKS_OAK, EnumBlockSoundEffectType.PLACE);
+            world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.SIGN_POST_PLANKS_OAK.id, MathHelper.floor((double)(((entityplayer.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
         } else
         {
-            world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Block.signWallPlanksOak, EnumBlockSoundEffectType.PLACE);
-            world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Block.signWallPlanksOak.id, sideHit);
+            world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.SIGN_WALL_PLANKS_OAK, EnumBlockSoundEffectType.PLACE);
+            world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.SIGN_WALL_PLANKS_OAK.id, sideHit);
         }
         itemstack.consumeItem(entityplayer);
-        TileEntitySign tileentitysign = (TileEntitySign)world.getBlockTileEntity(blockX, blockY, blockZ);
+        SignBlockEntity tileentitysign = (SignBlockEntity)world.getBlockEntity(blockX, blockY, blockZ);
         if(tileentitysign != null)
         {
             tileentitysign.setOwner(entityplayer);
diff --git a/src/main/java/net/minecraft/core/item/ItemSnowball.java b/src/main/java/net/minecraft/core/item/SnowballItem.java
similarity index 62%
rename from src/main/java/net/minecraft/core/item/ItemSnowball.java
rename to src/main/java/net/minecraft/core/item/SnowballItem.java
index fd3ee37fb..80f1c6ba1 100644
--- a/src/main/java/net/minecraft/core/item/ItemSnowball.java
+++ b/src/main/java/net/minecraft/core/item/SnowballItem.java
@@ -1,41 +1,41 @@
 package net.minecraft.core.item;
 
 // Referenced classes of package net.minecraft.src:
-//            Item, ItemStack, World, EntitySnowball, 
-//            EntityPlayer
+//            Item, ItemStack, World, SnowballProjectile,
+//            Player
 
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.entity.projectile.EntitySnowball;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.entity.projectile.SnowballProjectile;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class ItemSnowball
+public class SnowballItem
     extends Item
     implements IDispensable
 {
 
-    public ItemSnowball(String name, int id)
+    public SnowballItem(String name, String namespaceId, int id)
     {
-        super(name, id);
+        super(name, namespaceId, id);
         maxStackSize = 64;
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
     {
         itemstack.consumeItem(entityplayer);
         world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.5F, 0.4F / (itemRand.nextFloat() * 0.4F + 0.8F));
         if(!world.isClientSide)
         {
-            world.entityJoinedWorld(new EntitySnowball(world, entityplayer));
+            world.entityJoinedWorld(new SnowballProjectile(world, entityplayer));
         }
         return itemstack;
     }
 
     @Override
     public void onDispensed(ItemStack itemStack, World world, double x, double y, double z, int xOffset, int zOffset, Random random) {
-        EntitySnowball entitysnowball = new EntitySnowball(world, x, y, z);
+        SnowballProjectile entitysnowball = new SnowballProjectile(world, x, y, z);
         entitysnowball.setHeading(xOffset, 0.1D, zOffset, 1.1F, 6F);
         world.entityJoinedWorld(entitysnowball);
     }
diff --git a/src/main/java/net/minecraft/core/item/SoupItem.java b/src/main/java/net/minecraft/core/item/SoupItem.java
new file mode 100644
index 000000000..fe16aa866
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/SoupItem.java
@@ -0,0 +1,20 @@
+package net.minecraft.core.item;
+
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.world.World;
+
+public class SoupItem extends FoodItem
+{
+
+    public SoupItem(String name, String namespaceId, int id, int healAmount, int ticksPerHeal)
+    {
+        super(name, namespaceId, id, healAmount, ticksPerHeal, false, 1);
+    }
+
+    @Override
+    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+    {
+        ItemStack stack = super.onUseItem(itemstack, world, entityplayer);
+        return stack.stackSize <= 0 ? Items.BOWL.getDefaultStack() : stack;
+    }
+}
